package com.qadeer.inventory.service;

import com.qadeer.inventory.model.Product;
import com.qadeer.inventory.repository.ProductRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.web.multipart.MultipartFile;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;

@Service
public class ProductService {

    @Autowired
    private ProductRepository repository;

    public List<Product> getAllProducts() {
        return repository.findAll();
    }

    public Product getProductById(int id) {
        return repository.findById(id).get();
    }

    public void createProduct(Product product) {
        repository.save(product);
    }

    public List<Product> restock(MultipartFile file) throws IOException {
        InputStreamReader ir = new InputStreamReader(file.getInputStream());
        BufferedReader br = new BufferedReader(ir);
        String line = br.readLine();
        line = br.readLine();
        List<Product> productList = new ArrayList<>();
        while (line != null) {
            String[] content = line.split(",");
            String name = content[0].trim();
            int price = Integer.parseInt(content[1]);
            int quantity = Integer.parseInt(content[2]);
            Product product = new Product(name, price, quantity);
            repository.save(product);
            productList.add(product);
            line = br.readLine();
        }
        return productList;
    }

    public List<Product> buyProducts(String productName, int productQuantity) {
        List<Product> product = repository.findByName(productName);
        return product;
    }
}
